/**
 * 播放视频流
 * @param {Object} id 图片容器地址
 * @param {Object} vm 当前vue对象
 * @param {Object} refreshFlag 是否为视频预览页面
 */
function playVideo(id,vm,refreshFlag){
	if(ws){
		ws.close();
	}
	var host = window.location.host.split(':')[0];
	var path = '';
	if(sessionStorage.getItem('wspath')){
		if(sessionStorage.getItem('wspath')==1){
			//上镜头
			path = '';
		}else{
			path = '/admin';
		}
	}
	var url ='ws://'+ host +':9999' + path;
	if(cgi.getItem('wsvideo')){
		url =cgi.getItem('wsvideo') + path;
	}
	var count  = 0 ;//计数器
	var tempIntavil=null;
	var arrayWidths = [];
	var lockReconnect=false;
	
	//链接服务端
	var  ws = new WebSocket(url);
	var timeHeat = null;
	var maxT = 72*60*60*1000;
	var img_1 = document.getElementById(id);
	//配置客户端连接成功的回调方法
	ws.onopen = function(event) {
		console.log("open...");
		heartCheck.reset().start(); 
	};
	var img = new Image();
	img.onload = function() {
		img_1.src = img.src;
	}
//	var oldtime = new Date().valueOf();
	ws.onmessage = function(event) {
//		var curtime = new Date().valueOf()
//		logtime = curtime-oldtime;
//		console.log("当前时间:"+curtime+'-------'+"差值:"+logtime)
//		oldtime = curtime;
		//img.src = event.data;
		heartCheck.reset().start(); 
		 if(typeof(event.data)=="string"){ //字符串数据
		 	//var result = JSON.parse(event.data);
		 	console.log(event.data)
   		 }else{//视频图片流数据  
   		 	if(vm.canpaly){
   		 		var reader = new FileReader();
   		 		reader.readAsDataURL(event.data);
   		 		reader.onload = function(eve) {
   		 			img.src = this.result;
   		 			
   		 		};
   		 	}
		 }
	};
	ws.onerror = function(event) {
		console.log("error...");
		//console.log(event)
		//reconnect();
	}
	ws.onclose = function(event) {
		console.log("close...");
		reconnect();
	}
	
	//心跳检测
	var heartCheck = {
	    timeout: 3000,        //3秒发一次心跳
	    timeoutObj: null,
	    serverTimeoutObj: null,
	    reset: function () {
	        clearTimeout(this.timeoutObj);
	        clearTimeout(this.serverTimeoutObj);
	        return this;
	    },
	    start: function () {
	        var self = this;
	       	this.timeoutObj = setTimeout(function () {
                //这里发送一个心跳，后端收到后，返回一个心跳消息，
                //onmessage拿到返回的心跳就说明连接正常
                if(ws.readyState == 1){
                	ws.send("ping");
                	console.log('ping9999')
                }
                self.serverTimeoutObj = setTimeout(function () {
                    //如果超过一定时间还没重置，说明后端主动断开了
                    //如果onclose会执行reconnect，我们执行ws.close()就行了.如果直接执行reconnect 会触发onclose导致重连两次
//                 if(refreshFlag){
//						playVideo(id,vm,refreshFlag);
//					}else{
//						playVideo(id,vm);
//					} 
					ws.close()
                },self.timeout)
            },this.timeout)
	    }
	}
	 function reconnect() {
        if (lockReconnect) return;
        lockReconnect = true;
        setTimeout(function () {     //没连接上会一直重连，设置延迟避免请求过多
           if(refreshFlag){
				playVideo(id,vm,refreshFlag);
			}else{
				playVideo(id,vm);
			} 
            console.log('重连9999')
            lockReconnect = false;
        }, 2000);
    }
	 
	//心跳检查是否登入
	timeHeat = setInterval(function(){
		var time = cgi.getItem('times');
		var nowTime = new Date().getTime();
		if(time){
			var diffTime = nowTime-time;
			var maxTime = 1*60*1000;
			if(diffTime>maxTime){
				alert('登入超时!');
				cgi.setItem('times',new Date().getTime())
				window.top.location.href='login.html'
				clearInterval(timeHeat);
				return;
			}
		}
	},maxT)
	
}
//远程访问刷图片 1分钟刷一张
function refreshImage(id,vm){
	refreshImageFast(id)
	var img_1 = document.getElementById(id);
	var img = new Image()
	var imgInv = setInterval(function(){
		img.src = 'http://' + window.location.host + '/cgi-bin/snap.cgi?ver=' + Math.random();
		img.onload=function(){
			img_1.src = img.src
		}
	},60*1000)
}
//远程保存后立即刷图
function refreshImageFast(id){
	var power = JSON.parse(cgi.getItem('power'))
	if (power.remoteImg == 1 && !islocal()) {
		var img_1 = document.getElementById(id);
		var img = new Image()
		img.src =  'http://' + window.location.host + '/cgi-bin/snap.cgi?ver=' + Math.random();
		img.onload = function(){
			img_1.src = img.src
		}
		img.onerror = function(){
			img.src =  'http://' + window.location.host + '/cgi-bin/snap.cgi?ver=' + Math.random();
		}
	}
}